Package org.xnio.channels

# Class AssembledStreamChannel

java.lang.Object
org.xnio.channels.AssembledStreamChannel

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`, `ByteChannel`, `Channel`, `GatheringByteChannel`, `InterruptibleChannel`, `ReadableByteChannel`, `ScatteringByteChannel`, `WritableByteChannel`, `ByteChannel`, `CloseableChannel`, `Configurable`, `StreamChannel`, `StreamSinkChannel`, `StreamSourceChannel`, `SuspendableChannel`, `SuspendableReadChannel`, `SuspendableWriteChannel`

Direct Known Subclasses:
  `AssembledConnectedStreamChannel`

public class AssembledStreamChannel extends Object implements StreamChannel
A stream channel assembled from a stream source and stream sink.

Author:
  David M. Lloyd

## Field Summary

### Fields inherited from interface org.xnio.channels.Configurable

`EMPTY`

## Constructor Summary

Constructors
Constructor
Description
`AssembledStreamChannel(CloseableChannel closeable, StreamSourceChannel source, StreamSinkChannel sink)`
Construct a new instance.
`AssembledStreamChannel(StreamSourceChannel source, StreamSinkChannel sink)`
Construct a new instance.

## Method Summary

Modifier and Type
Method
Description
`void`
`awaitReadable()`
Block until this channel becomes readable again.
`void`
`awaitReadable(long time, TimeUnit timeUnit)`
Block until this channel becomes readable again, or until the timeout expires.
`void`
`awaitWritable()`
Block until this channel becomes writable again.
`void`
`awaitWritable(long time, TimeUnit timeUnit)`
Block until this channel becomes writable again, or until the timeout expires.
`void`
`close()`
Close this channel.
`boolean`
`flush()`
Flush any waiting partial send or write.
`ChannelListener.Setter<? extends AssembledStreamChannel>`
`getCloseSetter()`
Get the setter which can be used to change the close listener for this channel.
`XnioIoThread`
`getIoThread()`
Get the I/O thread associated with this channel.
`<T> T`
`getOption(Option<T> option)`
Get the value of a channel option.
`ChannelListener.Setter<? extends AssembledStreamChannel>`
`getReadSetter()`
Get the setter which can be used to change the read listener for this channel.
`XnioExecutor`
`getReadThread()`
Deprecated.
`XnioWorker`
`getWorker()`
Get the worker for this channel.
`ChannelListener.Setter<? extends AssembledStreamChannel>`
`getWriteSetter()`
Get the setter which can be used to change the write listener for this channel.
`XnioExecutor`
`getWriteThread()`
Deprecated.
`boolean`
`isOpen()`
Determine whether this channel is open.
`boolean`
`isReadResumed()`
Determine whether reads are resumed.
`boolean`
`isWriteResumed()`
Determine whether writes are resumed.
`int`
`read(ByteBuffer dst)`
`long`
`read(ByteBuffer[] dsts)`
`long`
`read(ByteBuffer[] dsts, int offset, int length)`
`void`
`resumeReads()`
Resume reads on this channel.
`void`
`resumeWrites()`
Resume writes on this channel.
`<T> T`
`setOption(Option<T> option, T value)`
Set an option for this channel.
`void`
`shutdownReads()`
Places this readable channel at "end of stream".
`void`
`shutdownWrites()`
Indicate that writing is complete for this channel.
`boolean`
`supportsOption(Option<?> option)`
Determine whether an option is supported on this channel.
`void`
`suspendReads()`
Suspend further read notifications on this channel.
`void`
`suspendWrites()`
Suspend further write notifications on this channel.
`long`
`transferFrom(FileChannel src, long position, long count)`
Transfer bytes into this channel from the given file.
`long`
`transferFrom(StreamSourceChannel source, long count, ByteBuffer throughBuffer)`
Transfers bytes from the given channel source.
`long`
`transferTo(long position, long count, FileChannel target)`
Transfers bytes into the given file from this channel.
`long`
`transferTo(long count, ByteBuffer throughBuffer, StreamSinkChannel target)`
Transfers bytes into the given channel target.
`void`
`wakeupReads()`
`Resume reads` on this channel, and force the read listener to be triggered even if the channel isn't actually readable.
`void`
`wakeupWrites()`
`Resume writes` on this channel, and force the write listener to be triggered even if the channel isn't actually writable.
`int`
`write(ByteBuffer src)`
`long`
`write(ByteBuffer[] srcs)`
`long`
`write(ByteBuffer[] srcs, int offset, int length)`
`int`
`writeFinal(ByteBuffer src)`
Writes some data to the channel, with the same semantics as `WritableByteChannel.write(java.nio.ByteBuffer)`.
`long`
`writeFinal(ByteBuffer[] srcs)`
Writes some data to the channel, with the same semantics as `GatheringByteChannel.write(java.nio.ByteBuffer[])`.
`long`
`writeFinal(ByteBuffer[] srcs, int offset, int length)`
Writes some data to the channel, with the same semantics as `GatheringByteChannel.write(java.nio.ByteBuffer[], int, int)`.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### AssembledStreamChannel

public AssembledStreamChannel(CloseableChannel closeable, StreamSourceChannel source, StreamSinkChannel sink)
Construct a new instance.

Parameters:
  `closeable` - the single central closeable channel
  `source` - the stream source channel
  `sink` - the stream sink channel

### AssembledStreamChannel

public AssembledStreamChannel(StreamSourceChannel source, StreamSinkChannel sink)
Construct a new instance.

Parameters:
  `source` - the stream source channel
  `sink` - the stream sink channel

## Method Details

### getReadSetter

public ChannelListener.Setter<? extends AssembledStreamChannel> getReadSetter()
Description copied from interface: `StreamChannel`
Get the setter which can be used to change the read listener for this channel.

Specified by:
  `getReadSetter` in interface `StreamChannel`
Specified by:
  `getReadSetter` in interface `StreamSourceChannel`
Specified by:
  `getReadSetter` in interface `SuspendableChannel`
Specified by:
  `getReadSetter` in interface `SuspendableReadChannel`
Returns:
  the setter

### suspendReads

public void suspendReads()
Description copied from interface: `SuspendableReadChannel`
Suspend further read notifications on this channel.

Specified by:
  `suspendReads` in interface `SuspendableReadChannel`

### resumeReads

public void resumeReads()
Description copied from interface: `SuspendableReadChannel`
Resume reads on this channel. The read listener will be called as soon as there is data available to be read.

Specified by:
  `resumeReads` in interface `SuspendableReadChannel`

### isReadResumed

public boolean isReadResumed()
Description copied from interface: `SuspendableReadChannel`
Determine whether reads are resumed.

Specified by:
  `isReadResumed` in interface `SuspendableReadChannel`
Returns:
  `true` if reads are resumed, `false` if reads are suspended

### wakeupReads

public void wakeupReads()
Description copied from interface: `SuspendableReadChannel`
`Resume reads` on this channel, and force the read listener to be triggered even if the channel isn't actually readable.

Specified by:
  `wakeupReads` in interface `SuspendableReadChannel`

### shutdownReads

public void shutdownReads() throws IOException
Description copied from interface: `SuspendableReadChannel`
Places this readable channel at "end of stream". Further reads will result in EOF. Shutting down all directions of a channel will cause `CloseableChannel.close()` to be called automatically.

Specified by:
  `shutdownReads` in interface `SuspendableReadChannel`
Throws:
  `IOException` - if an I/O error occurs

### awaitReadable

public void awaitReadable() throws IOException
Description copied from interface: `SuspendableReadChannel`
Block until this channel becomes readable again. This method may return spuriously before the channel becomes readable.

Specified by:
  `awaitReadable` in interface `SuspendableReadChannel`
Throws:
  `IOException` - if an I/O error occurs

### awaitReadable

public void awaitReadable(long time, TimeUnit timeUnit) throws IOException
Description copied from interface: `SuspendableReadChannel`
Block until this channel becomes readable again, or until the timeout expires. This method may return spuriously before the channel becomes readable or the timeout expires.

Specified by:
  `awaitReadable` in interface `SuspendableReadChannel`
Parameters:
  `time` - the time to wait
  `timeUnit` - the time unit
Throws:
  `IOException` - if an I/O error occurs

### getReadThread

@Deprecated public XnioExecutor getReadThread()
Deprecated.
Description copied from interface: `SuspendableReadChannel`
Get the read thread for this channel.

Specified by:
  `getReadThread` in interface `SuspendableReadChannel`
Returns:
  the thread, or `null` if none is configured or available

### getIoThread

public XnioIoThread getIoThread()
Description copied from interface: `CloseableChannel`
Get the I/O thread associated with this channel.

Specified by:
  `getIoThread` in interface `CloseableChannel`
Returns:
  the I/O thread associated with this channel

### read

public int read(ByteBuffer dst) throws IOException

Specified by:
  `read` in interface `ReadableByteChannel`
Throws:
  `IOException`

### read

public long read(ByteBuffer[] dsts, int offset, int length) throws IOException

Specified by:
  `read` in interface `ScatteringByteChannel`
Throws:
  `IOException`

### read

public long read(ByteBuffer[] dsts) throws IOException

Specified by:
  `read` in interface `ScatteringByteChannel`
Throws:
  `IOException`

### transferTo

public long transferTo(long position, long count, FileChannel target) throws IOException
Description copied from interface: `StreamSourceChannel`
Transfers bytes into the given file from this channel. Using this method in preference to `FileChannel.transferFrom(ReadableByteChannel, long, long)` may provide a performance advantage on some platforms.

If the current thread is interrupted when this method is called, it may throw a `InterruptedIOException`; however, if this exception is thrown, the `InterruptedIOException.bytesTransferred` field is guaranteed to be 0.

Specified by:
  `transferTo` in interface `StreamSourceChannel`
Parameters:
  `position` - the position within the file from which the transfer is to begin
  `count` - the number of bytes to be transferred
  `target` - the file to write to
Returns:
  the number of bytes (possibly 0) that were actually transferred
Throws:
  `IOException` - if an I/O error occurs

### transferTo

public long transferTo(long count, ByteBuffer throughBuffer, StreamSinkChannel target) throws IOException
Description copied from interface: `StreamSourceChannel`
Transfers bytes into the given channel target. On some platforms, this may avoid copying bytes between user and kernel space. On other platforms, bytes are passed through the `throughBuffer` parameter's buffer space. On entry, `throughBuffer` will be cleared. On exit, the buffer will be flipped for emptying, and may possibly be empty or may contain data. If this method returns a value less than `count`, then the remaining data in `throughBuffer` may contain data read from this channel which must be written to `target` to complete the operation. Note that using a direct buffer may provide an intermediate performance gain on platforms without zero-copy facilities.

If the current thread is interrupted when this method is called, it may throw a `InterruptedIOException`; however, if this exception is thrown, the `InterruptedIOException.bytesTransferred` field is guaranteed to be 0. Note that the return value is the amount of data that was actually transferred to the `StreamSinkChannel`. The actual amount of data read could be larger than this, and can be calculated by adding the return value and the amount of data left in `throughBuffer`.

Specified by:
  `transferTo` in interface `StreamSourceChannel`
Parameters:
  `count` - the number of bytes to be transferred
  `throughBuffer` - the buffer to copy through.
  `target` - the destination to write to
Returns:
  the number of bytes (possibly 0) that were actually transferred, or -1 if the end of input was reached
Throws:
  `IOException` - if an I/O error occurs

### transferFrom

public long transferFrom(FileChannel src, long position, long count) throws IOException
Description copied from interface: `StreamSinkChannel`
Transfer bytes into this channel from the given file. Using this method in preference to `FileChannel.transferTo(long, long, WritableByteChannel)` may provide a performance advantage on some platforms.

If the current thread is interrupted when this method is called, it may throw a `InterruptedIOException`; however, if this exception is thrown, the `InterruptedIOException.bytesTransferred` field is guaranteed to be 0.

Specified by:
  `transferFrom` in interface `StreamSinkChannel`
Parameters:
  `src` - the file to read from
  `position` - the position within the file from which the transfer is to begin
  `count` - the number of bytes to be transferred
Returns:
  the number of bytes (possibly 0) that were actually transferred
Throws:
  `IOException` - if an I/O error occurs

### transferFrom

public long transferFrom(StreamSourceChannel source, long count, ByteBuffer throughBuffer) throws IOException
Description copied from interface: `StreamSinkChannel`
Transfers bytes from the given channel source. On some platforms, this may avoid copying bytes between user and kernel space. On other platforms, bytes are passed through the `throughBuffer` parameter's buffer space. On entry, `throughBuffer` will be cleared. On exit, the buffer will be flipped for emptying, and may be empty or may contain data. If this method returns a value less than `count`, then the remaining data in `throughBuffer` may contain data read from `source` which must be written to this channel to complete the operation. Note that using a direct buffer may provide an intermediate performance gain on platforms without zero-copy facilities.

If the current thread is interrupted when this method is called, it may throw a `InterruptedIOException`; however, if this exception is thrown, the `InterruptedIOException.bytesTransferred` field is guaranteed to be 0.

Specified by:
  `transferFrom` in interface `StreamSinkChannel`
Parameters:
  `source` - the source to read from
  `count` - the number of bytes to be transferred
  `throughBuffer` - the buffer to copy through.
Returns:
  the number of bytes (possibly 0) that were actually transferred, or -1 if the end of input was reached
Throws:
  `IOException` - if an I/O error occurs

### getWriteSetter

public ChannelListener.Setter<? extends AssembledStreamChannel> getWriteSetter()
Description copied from interface: `StreamChannel`
Get the setter which can be used to change the write listener for this channel.

Specified by:
  `getWriteSetter` in interface `StreamChannel`
Specified by:
  `getWriteSetter` in interface `StreamSinkChannel`
Specified by:
  `getWriteSetter` in interface `SuspendableChannel`
Specified by:
  `getWriteSetter` in interface `SuspendableWriteChannel`
Returns:
  the setter

### write

public int write(ByteBuffer src) throws IOException

Specified by:
  `write` in interface `WritableByteChannel`
Throws:
  `IOException`

### write

public long write(ByteBuffer[] srcs, int offset, int length) throws IOException

Specified by:
  `write` in interface `GatheringByteChannel`
Throws:
  `IOException`

### write

public long write(ByteBuffer[] srcs) throws IOException

Specified by:
  `write` in interface `GatheringByteChannel`
Throws:
  `IOException`

### suspendWrites

public void suspendWrites()
Description copied from interface: `SuspendableWriteChannel`
Suspend further write notifications on this channel.

Specified by:
  `suspendWrites` in interface `SuspendableWriteChannel`

### resumeWrites

public void resumeWrites()
Description copied from interface: `SuspendableWriteChannel`
Resume writes on this channel. The write listener will be called as soon as the channel becomes writable.

Specified by:
  `resumeWrites` in interface `SuspendableWriteChannel`

### isWriteResumed

public boolean isWriteResumed()
Description copied from interface: `SuspendableWriteChannel`
Determine whether writes are resumed.

Specified by:
  `isWriteResumed` in interface `SuspendableWriteChannel`
Returns:
  `true` if writes are resumed, `false` if writes are suspended

### wakeupWrites

public void wakeupWrites()
Description copied from interface: `SuspendableWriteChannel`
`Resume writes` on this channel, and force the write listener to be triggered even if the channel isn't actually writable.

Specified by:
  `wakeupWrites` in interface `SuspendableWriteChannel`

### shutdownWrites

public void shutdownWrites() throws IOException
Description copied from interface: `SuspendableWriteChannel`
Indicate that writing is complete for this channel. Further attempts to write data to this channel after this method is invoked will result in an exception. If this method was already called, calling this method again will have no additional effect. After this method is called, any remaining data still must be flushed out via the `SuspendableWriteChannel.flush()` method; once this is done, if the read side of the channel was shut down, the channel will automatically close.

Specified by:
  `shutdownWrites` in interface `SuspendableWriteChannel`
Throws:
  `IOException` - if an I/O error occurs

### awaitWritable

public void awaitWritable() throws IOException
Description copied from interface: `SuspendableWriteChannel`
Block until this channel becomes writable again. This method may return spuriously before the channel becomes writable.

Specified by:
  `awaitWritable` in interface `SuspendableWriteChannel`
Throws:
  `IOException` - if an I/O error occurs

### awaitWritable

public void awaitWritable(long time, TimeUnit timeUnit) throws IOException
Description copied from interface: `SuspendableWriteChannel`
Block until this channel becomes writable again, or until the timeout expires. This method may return spuriously before the channel becomes writable or the timeout expires.

Specified by:
  `awaitWritable` in interface `SuspendableWriteChannel`
Parameters:
  `time` - the time to wait
  `timeUnit` - the time unit
Throws:
  `IOException` - if an I/O error occurs

### getWriteThread

@Deprecated public XnioExecutor getWriteThread()
Deprecated.
Description copied from interface: `SuspendableWriteChannel`
Get the write thread for this channel.

Specified by:
  `getWriteThread` in interface `SuspendableWriteChannel`
Returns:
  the thread, or `null` if none is configured or available

### flush

public boolean flush() throws IOException
Description copied from interface: `SuspendableWriteChannel`
Flush any waiting partial send or write. If there is no data to flush, or if the flush completed successfully, this method will return `true`. If there is data to flush which cannot be immediately written, this method will return `false`. If this method returns `true` after `SuspendableWriteChannel.shutdownWrites()` was called on this channel, the write listener will no longer be invoked on this channel. If this is case and additionally this is a write-only channel or the read side was previously shut down, then the channel will automatically be closed.

Specified by:
  `flush` in interface `SuspendableWriteChannel`
Returns:
  `true` if the message was flushed, or `false` if the result would block
Throws:
  `IOException` - if an I/O error occurs

### getCloseSetter

public ChannelListener.Setter<? extends AssembledStreamChannel> getCloseSetter()
Description copied from interface: `StreamChannel`
Get the setter which can be used to change the close listener for this channel. If the channel is already closed, then the listener will not be called.

Specified by:
  `getCloseSetter` in interface `CloseableChannel`
Specified by:
  `getCloseSetter` in interface `StreamChannel`
Specified by:
  `getCloseSetter` in interface `StreamSinkChannel`
Specified by:
  `getCloseSetter` in interface `StreamSourceChannel`
Specified by:
  `getCloseSetter` in interface `SuspendableChannel`
Specified by:
  `getCloseSetter` in interface `SuspendableReadChannel`
Specified by:
  `getCloseSetter` in interface `SuspendableWriteChannel`
Returns:
  the setter

### writeFinal

public int writeFinal(ByteBuffer src) throws IOException
Description copied from interface: `StreamSinkChannel`
Writes some data to the channel, with the same semantics as `WritableByteChannel.write(java.nio.ByteBuffer)`. If all the data is written out then the channel will have its writes shutdown. Semantically this method is equivalent to: `int rem = src.remaining(); int written = channel.write(src); if(written == rem) { channel.shutdownWrites() }` If an exception is thrown the caller is still responsible for closing the channel.

Specified by:
  `writeFinal` in interface `StreamSinkChannel`
Parameters:
  `src` - The data to write
Returns:
  The amount of data that was actually written.
Throws:
  `IOException`
See Also:
  - `WritableByteChannel.write(java.nio.ByteBuffer)`
  - `SuspendableWriteChannel.shutdownWrites()`

### writeFinal

public long writeFinal(ByteBuffer[] srcs, int offset, int length) throws IOException
Description copied from interface: `StreamSinkChannel`
Writes some data to the channel, with the same semantics as `GatheringByteChannel.write(java.nio.ByteBuffer[], int, int)`. If all the data is written out then the channel will have its writes shutdown. If an exception is thrown the caller is still responsible for closing the channel.

Specified by:
  `writeFinal` in interface `StreamSinkChannel`
Parameters:
  `srcs` - The buffers from which bytes are to be retrieved
  `offset` - The offset within the buffer array of the first buffer from which bytes are to be retrieved; must be non-negative and no larger than `srcs.length`
  `length` - The maximum number of buffers to be accessed; must be non-negative and no larger than `srcs.length` - `offset`
Returns:
  The amount of data that was actually written
Throws:
  `IOException`
See Also:
  - `GatheringByteChannel.write(java.nio.ByteBuffer[], int, int)`
  - `SuspendableWriteChannel.shutdownWrites()`

### writeFinal

public long writeFinal(ByteBuffer[] srcs) throws IOException
Description copied from interface: `StreamSinkChannel`
Writes some data to the channel, with the same semantics as `GatheringByteChannel.write(java.nio.ByteBuffer[])`. If all the data is written out then the channel will have its writes shutdown. If an exception is thrown the caller is still responsible for closing the channel.

Specified by:
  `writeFinal` in interface `StreamSinkChannel`
Parameters:
  `srcs` - The buffers from which bytes are to be retrieved
Returns:
  The amount of data that was actually written
Throws:
  `IOException`
See Also:
  - `GatheringByteChannel.write(java.nio.ByteBuffer[])`
  - `SuspendableWriteChannel.shutdownWrites()`

### getWorker

public XnioWorker getWorker()
Description copied from interface: `CloseableChannel`
Get the worker for this channel.

Specified by:
  `getWorker` in interface `CloseableChannel`
Returns:
  the worker

### close

public void close() throws IOException
Description copied from interface: `CloseableChannel`
Close this channel. When a channel is closed, its close listener is invoked. Invoking this method more than once has no additional effect.

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Channel`
Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in interface `CloseableChannel`
Specified by:
  `close` in interface `InterruptibleChannel`
Specified by:
  `close` in interface `SuspendableWriteChannel`
Throws:
  `IOException` - if the close failed

### isOpen

public boolean isOpen()
Description copied from interface: `SuspendableWriteChannel`
Determine whether this channel is open. This method will return `false` if all directions are shut down, even if there is unflushed write data pending.

Specified by:
  `isOpen` in interface `Channel`
Specified by:
  `isOpen` in interface `SuspendableWriteChannel`
Returns:
  `true` if the channel is open, `false` otherwise

### supportsOption

public boolean supportsOption(Option<?> option)
Description copied from interface: `Configurable`
Determine whether an option is supported on this channel.

Specified by:
  `supportsOption` in interface `Configurable`
Parameters:
  `option` - the option
Returns:
  `true` if it is supported

### getOption

public <T> T getOption(Option<T> option) throws IOException
Description copied from interface: `Configurable`
Get the value of a channel option.

Specified by:
  `getOption` in interface `Configurable`
Type Parameters:
  `T` - the type of the option value
Parameters:
  `option` - the option to get
Returns:
  the value of the option, or `null` if it is not set
Throws:
  `IOException` - if an I/O error occurred when reading the option

### setOption

public <T> T setOption(Option<T> option, T value) throws IllegalArgumentException, IOException
Description copied from interface: `Configurable`
Set an option for this channel. Unsupported options are ignored.

Specified by:
  `setOption` in interface `Configurable`
Type Parameters:
  `T` - the type of the option value
Parameters:
  `option` - the option to set
  `value` - the value of the option to set
Returns:
  the previous option value, if any
Throws:
  `IllegalArgumentException` - if the value is not acceptable for this option
  `IOException` - if an I/O error occurred when modifying the option